//******************************************************************************
// MIDIV[PT[\tgwEx
// ʃt[EBhENX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



// (ЂƂ̂܂ႭɂЂƂm)
typedef struct tagMusicalScoreNoteInfo {
	MIDIEvent* m_pNoteOnEvent;          // m[gICxgւ̃|C^
	MIDIEvent* m_pNoteOffEvent;         // m[gItCxgւ̃|C^
	long m_lNoteOnTime;                 // m[gI[Tick]
	long m_lNoteOnMeasure;              // m[gI
	long m_lNoteOnBeat;                 // m[gI
	long m_lNoteOnTick;                 // m[gIeBbN
	long m_lNoteOffTime;                // m[gIt[Tick]
	long m_lNoteOffMeasure;             // m[gIt
	long m_lNoteOffBeat;                // m[gIt
	long m_lNoteOffTick;                // m[gIteBbN
	long m_lFlags;                      // tO
	long m_lSelected;                   // I
	struct tagMusicalScoreNoteInfo* m_pPrevNoteInfo; // ̉ւ̃|C^(ȂNULL)
	struct tagMusicalScoreNoteInfo* m_pNextNoteInfo; // Ỏւ̃|C^(ȂNULL)
	void* m_pNoteGroupInfo;             // O[vւ̃|C^(ȂNULL)
	void* m_pTripletGroupInfo;          // 3AO[vւ̃|C^(ȂNULL)
} MusicalScoreNoteInfo;

// O[v(̉Ȃđ˂)
typedef struct tagMusicalScoreNoteGroupInfo {
	MusicalScoreNoteInfo* m_pFirstNoteInfo; // ŏ̉ւ̃|C^
	MusicalScoreNoteInfo* m_pLastNoteInfo;  // Ō̉ւ̃|C^
	long m_lBeginTime;                  // Jn
	long m_lEndTime;                    // I
	long m_lMinKey;                     // ŒቹK(0-127)
	long m_lMaxKey;                     // ōK(0-127)
	long m_lMinDur;                     // ŒZ
	long m_lMaxDur;                     // Œ
	long m_lNumNoteInfo;                // O[v̉
} MusicalScoreNoteGroupInfo;

// 3AO[v(̉-3-łȂđ˂)
typedef struct tagMusicalScoreTripletGroupInfo {
	MusicalScoreNoteInfo* m_pFirstNoteInfo; // ŏ̉ւ̃|C^
	MusicalScoreNoteInfo* m_pLastNoteInfo;  // Ō̉ւ̃|C^
	long m_lBeginTime;                  // Jn
	long m_lEndTime;                    // I
	long m_lMinKey;                     // ŒቹK(0-127)
	long m_lMaxKey;                     // ōK(0-127)
	long m_lMinDur;                     // ŒZ
	long m_lMaxDur;                     // Œ
	long m_lNumNoteInfo;                // O[v̉
} MusicalScoreTripletGroupInfo;

// gbN
typedef struct {
	long m_lTop;                        // [W[pixel]
	long m_lHeight;                     // [pixel]
	long m_lFlags;                      // tO
	long m_lMinKey;                     // gbNŒቹK(0-127)
	long m_lMaxKey;	                    // gbNōK(0-127)
	CPtrArray m_theNoteInfoArray;       // ̔z
	CPtrArray m_theNoteGroupInfoArray;  // O[v̔z
	CPtrArray m_theTripletGroupInfoArray; // 3AO[v̔z
	long m_lTopPrint;                   // [W(p)[*1/10mm]
	long m_lHeightPrint;                // (p)[*1/10mm]
} MusicalScoreTrackInfo;

// ߏ
typedef struct {
	long m_lTime;                       // ̏߂̊Jn^C[Tick][Subframe]
	long m_lDuration;                   // ̏߂ɂ̒[Tick][Subframe]
	long m_lLeft;                       // ̏߂̍W[pixel]
	long m_lSignatureWidth;             // ̏߂̔qLELp[pixel]
	long m_lPreWidth;                   // ̏߂̍][pixel]
	long m_lWidth;                      // ̏߂̕[pixel]
	long m_lPostWidth;                  // ̏߂̉E][pixel]
	long m_lFlags;                      // tO
	long m_lTimeSignature;              // ̏߂̔qL
	long m_lKeySignature;               // ̏߂̒L
	long m_lLeftPrint;                  // ̏߂̍W(p)[*1/10mm]
	long m_lSignatureWidthPrint;        // ̏߂̔qLELp(p)[*1/10mm]
	long m_lPreWidthPrint;              // ̏߂̍](p)[*1/10mm]
	long m_lWidthPrint;                 // ̏߂̕(p)[*1/10mm] 
	long m_lPostWidthPrint;             // ̏߂̉E][pixel](p)[*1/10mm]
} MusicalScoreMeasureInfo;




class CMusicalScoreFrame : public CChildFrame {
	DECLARE_DYNCREATE (CMusicalScoreFrame)

	//-------------------------------------------------------------------------
	// Agr[g
	//-------------------------------------------------------------------------
protected:
	long m_lToolBar1Height;             // c[o[1̍[pixel]
	long m_lKeyHeight;                  // gbNԍ-ԃr[̍[pixel]
	long m_lScaleHeight;                // 㕔ڐr[̍[pixel]
	long m_lScaleWidth;                 // ڐr[̍[pixel]
	long m_lTimeWidth;                  // gbNԍ[-ԃr[̕[pixel]
	long m_lHScrollBarHeight;           // XN[o[̍[pixel]
	long m_lVScrollBarWidth;            // XN[o[̍[pixel]
	long m_lTrackListWidth;             // gbNXg{bNX̕[pixel]
	long m_lTrackZoom;                  // gbNg{[{]
	long m_lTimeZoom;                   // ԕg{[{]
	long m_lTrackScrollPos;             // gbNXN[ʒu[pixel]
	long m_lTimeScrollPos;              // ԕXN[ʒu[pixel]
public:
	// `⏕
	CPtrArray   m_theTrackInfoArray;    // gbNƂ̏
	CPtrArray   m_theMeasureInfoArray;  // ߂Ƃ̏

public:
	CFont m_theFont;                    // ʃEBhEŎgtHg
	CFont m_theTimeMeasureFont;         // qLELp̃tHg
	CSekaijuToolBar m_wndToolBar1;      // c[o[1()
	CColorfulComboBox m_wndTrackCombo;  // c[o[̃gbNR{{bNX
	CComboBox m_wndChannelCombo;        // c[o[̃`lR{{bNX
	CComboBox m_wndSnapCombo;           // c[o[̃XibvR{{bNX
	CComboBox m_wndVelocityCombo;       // c[o[̃xVeBR{{bNX
	CComboBox m_wndDurationCombo;       // c[o[̉R{{bNX
	CComboBox m_wndResolutionCombo;     // c[o[̕\xR{{bNX
	CView* m_pDummyView;                // _~[r[(Visible=FALSE)ւ̃|C^
	CView* m_pPrintView;                // pr[(Visible=FALSE)ւ̃|C^
	CView* m_pScaleView;                // ڐr[ւ̃|C^
	CView* m_pTimeScaleView;            // Ԗڐr[ւ̃|C^
	CView* m_pTrackScaleView;           // gbNԍڐr[ւ̃|C^
	CView* m_pTrackTimeView;            // gbNԍ-^Cr[ւ̃|C^
	CCheckListBox* m_pTrackListBox;     // gbNXg{bNX
	CScrollBar m_wndTimeScroll;         // ԕXN[o[
	CScrollBar m_wndTrackScroll;        // gbNXN[o[
	CScrollBar m_wndSizeScroll;         // TCYpXN[o[
	CBitmapButton m_wndTimeZoomUp;      // ԕg{^
	CBitmapButton m_wndTimeZoomDown;    // ԕk{^
	CBitmapButton m_wndTrackZoomUp;     // gbNg{^
	CBitmapButton m_wndTrackZoomDown;   // gbNk{^

protected:
	CPoint m_ptMouseDown;               // }EXꂽƂ̍W(Xvb^[𓮂̂Ɏg)
	CPoint m_ptMouseMoveOld;            // }EXꂽƂ̑O̍W(Xvb^[𓮂̂Ɏg)
	BOOL m_bSplitterMovingH;            // ݐXvb^[𓮂ĂƂ납H
	BOOL m_bSplitterMovingV;            // ݐXvb^[𓮂ĂƂ납H

public:
	BOOL m_bAutoPageUpdate;             // IɃy[WXV邩H
	long m_lCurTool;                    // ݂̑IĂc[(0=`,1=,2=S,3=I,4=)

protected:
	BOOL m_bOnlyCurTrack;               // ݂̃gbN݂̂\邩H
	BOOL m_bShowAllTrack;               // ׂẴgbN\邩H
	BOOL m_bTrackVisible[MAXMIDITRACKNUM]; // gbN[0`65535]͉H

	//-------------------------------------------------------------------------
	// \zƔj
	//-------------------------------------------------------------------------
public:
	CMusicalScoreFrame ();              // RXgN^
	virtual ~CMusicalScoreFrame ();     // fXgN^

	//-------------------------------------------------------------------------
	// Iy[V
	//-------------------------------------------------------------------------
public:
	virtual CSekaijuDoc* GetDocument ();
	virtual long GetTimeZoom ();
	virtual long GetTrackZoom ();
	virtual long XtoTime (long x);
	virtual long TimetoX (long lTime);
	virtual long MeasuretoX (long lMeasure);
	virtual long MeasuretoX2 (long lMeasure);
	virtual long YtoTrackIndex (long y);
	virtual long TrackIndexYtoKey (long lTrackIndex, long y, long lKeySignature);
	virtual long KeytoLineNo (long lKey, long lKeySignature);
	virtual long KeytoSF (long lKey, long lKeySignature);
	virtual long TrackIndexLineNotoY (long lTrackIndex, long lLineNo);
	virtual long TrackIndexKeytoY (long lTrackIndex, long lKey, long lKeySignature);
	virtual long GetTimeScrollPos ();
	virtual long GetTrackScrollPos ();
	virtual long SetTimeScrollPos (long lTimeScrollPos);
	virtual long SetTrackScrollPos (long lTrackScrollPos);
	virtual long GetVisibleLeftTime ();
	virtual long GetVisibleRightTime ();
	virtual long GetVisibleTopTrack ();
	virtual long GetVisibleBottomTrack ();
	virtual void DrawSplitterCaptor (CDC* pDC, CPoint pt);
	virtual long GetCurTrackIndex ();
	virtual long GetCurChannel ();
	virtual long GetCurSnap ();
	virtual long GetCurVelocity ();
	virtual long GetCurDuration ();
	virtual long GetCurResolution ();
	virtual BOOL SetCurTrackIndex (long lCurTrackIndex);
	virtual BOOL SetCurChannel (long lCurChannel);
	virtual BOOL SetCurSnap (long lCurSnap);
	virtual BOOL SetCurVelocity (long lCurVelocity);
	virtual BOOL SetCurDuration (long lCurDuration);
	virtual BOOL SetCurResolution (long lCurResolution);
	virtual BOOL IsTrackVisible (long lTrackIndex);
	virtual BOOL SetTrackVisible (long lTrackIndex);
	virtual BOOL UpdateTrackCombo ();
	virtual BOOL UpdateTrackList ();
	virtual BOOL UpdateSnapCombo ();
	virtual BOOL UpdateVelocityCombo ();
	virtual BOOL UpdateDurationCombo ();
	virtual BOOL UpdateResolutionCombo ();
	virtual void RecalcTrackScrollInfo ();
	virtual void RecalcTimeScrollInfo ();


	virtual BOOL DeleteTrackInfoArray ();
	virtual BOOL DeleteMeasureInfoArray ();
	virtual BOOL DeleteNoteInfoArray (long lTrackIndex);
	virtual BOOL DeleteNoteGroupInfoArray (long lTrackIndex);
	virtual BOOL DeleteTripletGroupInfoArray (long lTrackIndex);
	virtual BOOL UpdateMeasureInfoArray ();
	virtual BOOL UpdateTrackInfoArray ();
	virtual BOOL UpdateNoteInfoArray (long lTrackIndex, MIDITrack* pMIDITrack);
	virtual BOOL UpdateNoteGroupInfoArray (long lTrackIndex, MIDITrack* pMIDITrack);
	virtual BOOL UpdateTripletGroupInfoArray (long lTrackIndex, MIDITrack* pMIDITrack);
	virtual MusicalScoreNoteInfo* CreateNote
		(MIDIEvent* pNoteEvent, long lNoteOnTime, long lNoteOnMeasure, long lNoteOnBeat, long lNoteOnTick, 
		long lNoteOffTime, long lNoteOffMeasure, long lNoteOffBeat, long lNoteOffTick, long lFlags);
	virtual void DeleteNoteInfo (MusicalScoreNoteInfo* pNoteInfo);
	virtual BOOL AddNoteInfo (MusicalScoreTrackInfo* pTrackInfo, MusicalScoreNoteInfo* pNoteInfo);
	MusicalScoreNoteGroupInfo* CreateNoteGroupInfo (MusicalScoreNoteInfo* pNoteInfo);
	void DeleteNoteGroupInfo (MusicalScoreNoteGroupInfo* pNoteGroupInfo);
	BOOL AddNoteGroupInfo (MusicalScoreTrackInfo* pTrackInfo, MusicalScoreNoteGroupInfo* pNoteGroupInfo);
	MusicalScoreTripletGroupInfo* CreateTripletGroupInfo (MusicalScoreNoteInfo* pNoteInfo);
	void DeleteTripletGroupInfo (MusicalScoreTripletGroupInfo* pTripletGroupInfo);
	BOOL AddTripletGroupInfo (MusicalScoreTrackInfo* pTrackInfo, MusicalScoreTripletGroupInfo* pNoteGroupInfo);

	virtual long GetTrackInfoCount ()
		{return m_theTrackInfoArray.GetSize ();} 
	virtual MusicalScoreTrackInfo* GetTrackInfo (long lTrackIndex)
		{return lTrackIndex < m_theTrackInfoArray.GetSize () ? 
		((MusicalScoreTrackInfo*)m_theTrackInfoArray.GetAt (lTrackIndex)) : NULL;}

	virtual long GetMeasureInfoCount ()
		{return m_theMeasureInfoArray.GetSize ();}
	virtual MusicalScoreMeasureInfo* GetMeasureInfo (long lMeasureIndex)
		{return lMeasureIndex < m_theMeasureInfoArray.GetSize () ?
		((MusicalScoreMeasureInfo*)m_theMeasureInfoArray.GetAt (lMeasureIndex)) : NULL;}
	virtual long GetMeasureTime (long lMeasureIndex)
		{return lMeasureIndex < m_theMeasureInfoArray.GetSize () ?
		((MusicalScoreMeasureInfo*)m_theMeasureInfoArray.GetAt (lMeasureIndex))->m_lTime : 0;}
	virtual long GetMeasureLeft (long lMeasureIndex)
		{return lMeasureIndex < m_theMeasureInfoArray.GetSize () ?
		((MusicalScoreMeasureInfo*)m_theMeasureInfoArray.GetAt (lMeasureIndex))->m_lLeft : 0;}


	//-------------------------------------------------------------------------
	// I[o[Ch
	//-------------------------------------------------------------------------
protected:
	virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
	virtual void OnUpdateFrameTitle (BOOL bAddToTitle);
	virtual void RecalcLayout (BOOL bNotify = TRUE);
	virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

	//-------------------------------------------------------------------------
	// bZ[W}bv
	//-------------------------------------------------------------------------
protected:
	afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy ();
	afx_msg void OnSize (UINT nType, int cx, int cy);
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd (CDC* pDC);

	afx_msg void OnMDIActivate (BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd);
	afx_msg void OnPaint ();
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnTimeZoomDown ();
	afx_msg void OnTimeZoomUp ();
	afx_msg void OnTrackZoomDown ();
	afx_msg void OnTrackZoomUp ();
	afx_msg void OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMusicalScorePen ();
	afx_msg void OnUpdateMusicalScorePenUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreLine ();
	afx_msg void OnUpdateMusicalScoreLineUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreEraser ();
	afx_msg void OnUpdateMusicalScoreEraserUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreSelect ();
	afx_msg void OnUpdateMusicalScoreSelectUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreSpeaker ();
	afx_msg void OnUpdateMusicalScoreSpeakerUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreWholeNote ();
	afx_msg void OnUpdateMusicalScoreWholeNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreHalfNote ();
	afx_msg void OnUpdateMusicalScoreHalfNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreQuarterNote ();
	afx_msg void OnUpdateMusicalScoreQuarterNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreQuaverNote ();
	afx_msg void OnUpdateMusicalScoreQuaverNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreSemiQuaverNote ();
	afx_msg void OnUpdateMusicalScoreSemiQuaverNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreDemiSemiQuaverNote ();
	afx_msg void OnUpdateMusicalScoreDemiSemiQuaverNoteUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreDotted ();
	afx_msg void OnUpdateMusicalScoreDottedUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreTriplet ();
	afx_msg void OnUpdateMusicalScoreTripletUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreOnlyCurTrack ();
	afx_msg void OnUpdateMusicalScoreOnlyCurTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreShowAllTrack ();
	afx_msg void OnUpdateMusicalScoreShowAllTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnMusicalScoreAutoPageUpdate ();
	afx_msg void OnUpdateMusicalScoreAutoPageUpdateUI (CCmdUI* pCmdUI);

	afx_msg void OnTrackComboSelEndOK ();	
	afx_msg void OnTrackListChkChange ();
	afx_msg void OnTrackListSelChange ();
	afx_msg void OnSnapComboSelEndOK ();
	afx_msg void OnResolutionComboSelEndOK ();

	afx_msg void OnPopupTrackVisibleOn ();
	afx_msg void OnUpdatePopupTrackVisibleOnUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupTrackVisibleOff ();
	afx_msg void OnUpdatePopupTrackVisibleOffUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupTrackVisibleAll ();
	afx_msg void OnUpdatePopupTrackVisibleAllUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupEventProperty ();
	afx_msg void OnUpdatePopupEventPropertyUI (CCmdUI* pCmdUI);

	DECLARE_MESSAGE_MAP()
};


