//******************************************************************************
// MIDIV[PT[\tgwEx
// sAm[r[NX
// (C)2002-2011 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _MUSICALSCOREPRINTVIEW_H_
#define _MUSICALSCOREPRINTVIEW_H_

class CMusicalScorePrintView : public CSekaijuView {
	DECLARE_DYNCREATE (CMusicalScorePrintView)

	// CMusicalScoreFrameCMusicalScorePrintView::OnCmdMsǧĂяoB
	friend class CMusicalScoreFrame;

	// ֌W
	CSize m_sizDevPaper;                // TCY[hbg]
	CSize m_sizLogPaper;                // _TCY[*1/10mm]
	CSize m_sizLogPrinterDPI;           // v^DPI
	CFont m_theFont;                    // ptHg
	long m_lMaxRowPage;                 // őy[W(c)
	long m_lMaxRollPage;                // őy[W(ʃ[)
	long m_lMaxPage;                    // őy[W(c*ʃ[)
	CUIntArray m_theRowPageInfoArray;    // c̃y[Wz(擪ߔԍ)
	CUIntArray m_theRollPageInfoArray;   // ʃ[̃y[Wz(擪gbNԍ)

	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CMusicalScorePrintView ();             // RXgN^
	virtual ~CMusicalScorePrintView ();    // fXgN^

	//------------------------------------------------------------------------------
	// Iy[V
	//------------------------------------------------------------------------------

protected:
	
	long GetRowPageInfoCount () {return m_theRowPageInfoArray.GetSize ();};
	long GetRollPageInfoCount () {return m_theRollPageInfoArray.GetSize ();};

	void CalcMeasureInfoArray ();
	void CalcTrackInfoArray ();

	long TrackIndexLineNotoY (long lTrackIndex, long lLineNo);
	long TrackIndexKeytoY (long lTrackIndex, long lKey, long lKeySignature);
	long TimetoX (long lTime);
	long MeasuretoX (long lMeasure);
	long MeasuretoX2 (long lMeasure);
	
	void DrawTadpole (CDC* pDC, long x, long y, long rx, long ry, long lFlags);
	void DrawGClef (CDC* pDC, long x, long y, long rx, long ry);
	void DrawFClef (CDC* pDC, long x, long y, long rx, long ry);
	void DrawFlat (CDC* pDC, long x, long y, long rx, long ry);
	void DrawSharp (CDC* pDC, long x, long y, long rx, long ry);
	void DrawNatural (CDC* pDC, long x, long y, long rx, long ry);
	void DrawTimeAndKeySignature (CDC* pDC, long lTrackIndex, long lTime);
	void DrawHorzAuxiliaryLine (CDC* pDC, long x, long y, long r, long lFlags);
	void DrawDot (CDC* pDC, long x, long y, long rx, long ry, long lFlags);
	void DrawTieHalf (CDC* pDC, long x1, long x2, long y, long rx, long ry, long lFlags);
	void DrawPole (CDC* pDC, long x1, long x2, long y1, long y2, long rx, long ry, long lFlags);
	void DrawSingleFlag (CDC* pDC, long x1, long x2, long y1, long y2, long rx, long ry, long lFlags);
	void DrawChainedFlag (CDC* pDC, long x1, long x2, long y1, long y2, long rx, long ry, long lFlags);
	void DrawTripletSign (CDC* pDC, long x1, long x2, long y1, long y2, long rx, long ry, long lFlags);
	void DrawNote (CDC* pDC, long lTrackIndex, MusicalScoreNoteInfo* pNoteInfo, long lFlags);
	void DrawFlagAndText (CDC* pDC, long lTime, LPCTSTR lpszText, long lColor);

	void DrawTrackScaleView (CDC* pDC, CPrintInfo* pInfo);
	void DrawTrackTimeView (CDC* pDC, CPrintInfo* pInfo);
	void DrawScaleView (CDC* pDC, CPrintInfo* pInfo);
	void DrawTimeScaleView (CDC* pDC, CPrintInfo* pInfo);

	CString GetCellString (long lTrack);

	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual void OnPrint (CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnPreparePrinting (CPrintInfo* pInfo);
	virtual void OnBeginPrinting (CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting (CDC* pDC, CPrintInfo* pInfo);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	DECLARE_MESSAGE_MAP ()

};

#endif

