//******************************************************************************
// MIDIV[PT[\tgwEx
// CxgXgt[EBhENX
// (C)2002-2012 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _EVENTLISTFRAME_H_
#define _EVENTLISTFRAME_H_

class CEventListFrame : public CChildFrame {
	DECLARE_DYNCREATE (CEventListFrame)

	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
protected:
	long m_lToolBar1Height;             // c[o[̍[pixel]
	long m_lScaleHeight;                // ږڐr[̍[pixel]
	long m_lIndexHeight;                // Cxgԍ-ڃr[̍[pixel]
	long m_lScaleWidth;                 // Cxgԍڐr[̕[pixel]
	long m_lPropertyWidth;              // Cxgԍ-ڃr[̕[pixel]
	long m_lTrackListWidth;             // gbNXg{bNX̕[pixel]
	long m_lTrackListHeight;            // gbNXg{bNX̍[pixel]
	long m_lEventKindListHeight;        // Cxg̎ރXg{bNX̍[pixel]
	long m_lHScrollBarHeight;           // XN[o[̍[pixel]
	long m_lVScrollBarWidth;            // XN[o[̕[pixel]
	long m_lRowZoom;                    // sY[{[{]
	long m_lColumnZoom;                 // Y[{[{]
	long m_lRowScrollPos;               // sXN[ʒu[pixel]
	long m_lColumnScrollPos;            // XN[ʒu[pixel]

public:
	CSekaijuToolBar m_wndToolBar1;      // c[o[
	CColorfulComboBox m_wndEventTrackCombo; // c[o[̃Cxg̃gbNԍR{{bNX
	CEdit m_wndEventTimeEdit;           // c[o[̃Cxg̃^CGfBbg{bNX
	CComboBox m_wndEventKindCombo;      // c[o[̃Cxg̎ރR{{bNX
	CComboBox m_wndEventChannelCombo;   // c[o[̃Cxg̃`lR{{bNX
	CView* m_pDummyView;                // _~[r[(Visible=FALSE)ւ̃|C^
	CView* m_pPrintView;                // pr[(Visible=FALSE)ւ̃|C^
	CView* m_pScaleView;                // ڐr[ւ̃|C^
	CView* m_pPropertyScaleView;        // ږڐr[ւ̃|C^
	CView* m_pIndexScaleView;           // Cxgԍڐr[ւ̃|C^
	CView* m_pIndexPropertyView;        // Cxgԍ-ڃr[ւ̃|C^
	CCheckListBox* m_pTrackListBox;     // gbNXg{bNXւ̃|C^
	CCheckListBox* m_pEventKindListBox; // Cxg̎ރXg{bNXւ̃|C^
	CScrollBar m_wndColumnScroll;       // XN[o[
	CScrollBar m_wndRowScroll;          // sXN[o[
	CScrollBar m_wndSizeScroll;         // TCYXN[o[
	CBitmapButton m_wndColumnZoomUp;    // g{^
	CBitmapButton m_wndColumnZoomDown;  // k{^
	CBitmapButton m_wndRowZoomUp;       // sg{^
	CBitmapButton m_wndRowZoomDown;     // sk{^

public:
	BOOL m_bAutoPageUpdate;             // IɃy[WXV邩H

protected:
	CPoint m_ptMouseDown;               // }EXꂽƂ̍W(Xvb^[𓮂̂Ɏg)
	CPoint m_ptMouseMoveOld;            // }EXꂽƂ̑O̍W(Xvb^[𓮂̂Ɏg)
	BOOL m_bSplitterMovingH;            // ݐXvb^[𓮂ĂƂ납H
	BOOL m_bSplitterMovingV;            // ݐXvb^[𓮂ĂƂ납H
	CPtrArray m_theVisibleEventArray;   // \Cxgւ̃|C^̔z
	CFont m_theFont;                    // CxgXgEBhEŎgtHg
	long m_lColumnBaseWidth[8];         // e̕[pixel]
	CString m_strColumnTitle[8];        // ẽ^Cg(F"gbN", "::b:~b"...)

protected:
	BOOL m_bOnlyCurTrack;               // ݂̃gbN݂̂\邩H
	BOOL m_bShowAllTrack;               // ׂẴgbN\邩H
	BOOL m_bTrackVisible[MAXMIDITRACKNUM]; // eX̃gbN[0`65525]͉H
	BOOL m_bOnlyCurEventKind;           // ݂̃Cxg̎ނ݂̂\邩H
	BOOL m_bShowAllEventKind;           // ׂẴCxg̎ނ\邩H
	BOOL m_bEventKindVisible[256];      // eX̃Cxg̎[0`255]͉H

	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CEventListFrame ();                 // RXgN^
	virtual ~CEventListFrame ();        // fXgN^

	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
public:
	virtual CSekaijuDoc* GetDocument ();
	virtual CFont* GetParentFont ();
	virtual long GetVisibleTopRow ();
	virtual long GetVisibleBottomRow ();
	virtual long GetColumnBaseWidth (long lColumn);
	virtual long SetColumnBaseWidth (long lColumn, long lBaseWidth);
	virtual CString GetColumnTitle (long lColumn);
	virtual long SetColumnTitle (long lColumn, const TCHAR* pszColumnTitle);
	virtual long GetColumnLeft (long lColumn);
	virtual long GetColumnWidth (long lColumn);
	virtual long XtoColumn (long x);
	virtual long ColumntoX (long lColumn);
	virtual long YtoRow (long y);
	virtual long RowtoY (long lRow);
	virtual long GetColumnZoom ();
	virtual long GetRowZoom ();
	virtual long GetColumnScrollPos ();
	virtual long GetRowScrollPos ();
	virtual long SetColumnScrollPos (long lColumnScrollPos);
	virtual long SetRowScrollPos (long lRowScrollPos);
	virtual long GetVisibleEventCount ();
	virtual MIDIEvent* GetVisibleEvent (long lIndex);
	virtual void DrawSplitterCaptor (CDC* pDC, CPoint pt);
	virtual BOOL MakeVisibleEventArray ();
	virtual BOOL ReplaceVisibleEvent (MIDIEvent* pOldEvent, MIDIEvent* pNewEvent);
	virtual long GetCurTrackIndex ();
	virtual long GetCurEventKind ();
	virtual BOOL SetCurTrackIndex (long lCurTrackIndex);
	virtual BOOL SetCurEventKind (long lCurEventKind);
	virtual BOOL SetCurChannel (long lCurChannel);
	virtual BOOL IsTrackVisible (long lTrackIndex);
	virtual BOOL SetTrackVisible (long lTrackIndex);
	virtual BOOL IsEventKindVisible (long lEventKind);
	virtual BOOL SetEventKindVisible (long lEventKind);
	virtual BOOL UpdateTrackCombo ();
	virtual BOOL UpdateTrackList ();
	virtual long EventKindtoListIndex (long lEventKind);
	virtual long ListIndextoEventKind (long lListIndex);
	virtual void RecalcRowScrollInfo ();
	virtual void RecalcColumnScrollInfo ();

	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
	virtual void OnUpdateFrameTitle (BOOL bAddToTitle);
	virtual void RecalcLayout (BOOL bNotify = TRUE);
	virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy ();
	afx_msg void OnSize (UINT nType, int cx, int cy);
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd (CDC* pDC);
	afx_msg void OnMDIActivate (BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd);
	afx_msg void OnClose ();
	afx_msg void OnPaint();
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnColumnZoomDown ();
	afx_msg void OnColumnZoomUp ();
	afx_msg void OnRowZoomDown ();
	afx_msg void OnRowZoomUp ();
	afx_msg void OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);


	afx_msg void OnEventListInsertEvent ();
	afx_msg void OnUpdateEventListInsertEventUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListDuplicateEvent ();
	afx_msg void OnUpdateEventListDuplicateEventUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListDeleteEvent ();
	afx_msg void OnUpdateEventListDeleteEventUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListOnlyCurTrack ();
	afx_msg void OnUpdateEventListOnlyCurTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListShowAllTrack ();
	afx_msg void OnUpdateEventListShowAllTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListOnlyCurEventKind ();
	afx_msg void OnUpdateEventListOnlyCurEventKindUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListShowAllEventKind ();
	afx_msg void OnUpdateEventListShowAllEventKindUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListAutoPageUpdate ();
	afx_msg void OnUpdateEventListAutoPageUpdateUI (CCmdUI* pCmdUI);
	afx_msg void OnEventListSaveAs ();
	afx_msg void OnUpdateEventListSaveAsUI (CCmdUI* pCmdUI);

	afx_msg void OnTrackComboSelEndOK ();
	afx_msg void OnTrackListChkChange ();
	afx_msg void OnTrackListSelChange ();

	afx_msg void OnEventKindComboSelEndOK ();	
	afx_msg void OnEventKindListChkChange ();
	afx_msg void OnEventKindListSelChange ();

	afx_msg void OnPopupTrackVisibleOn ();
	afx_msg void OnUpdatePopupTrackVisibleOnUI (CCmdUI* pCmdUI); // 20100429ǉ
	afx_msg void OnPopupTrackVisibleOff ();
	afx_msg void OnUpdatePopupTrackVisibleOffUI (CCmdUI* pCmdUI); // 20100429ǉ
	afx_msg void OnPopupTrackVisibleAll ();
	afx_msg void OnUpdatePopupTrackVisibleAllUI (CCmdUI* pCmdUI); // 20100429ǉ
	afx_msg void OnPopupEventKindVisibleOn ();
	afx_msg void OnUpdatePopupEventKindVisibleOnUI (CCmdUI* pCmdUI); // 20100429ǉ
	afx_msg void OnPopupEventKindVisibleOff ();
	afx_msg void OnUpdatePopupEventKindVisibleOffUI (CCmdUI* pCmdUI); // 20100429ǉ
	afx_msg void OnPopupEventKindVisibleAll ();
	afx_msg void OnUpdatePopupEventKindVisibleAllUI (CCmdUI* pCmdUI); // 20100429ǉ

	DECLARE_MESSAGE_MAP()
};

#endif

