//******************************************************************************
// MIDIV[PT[\tgwEx
// sAm[t[EBhENX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _PIANOROLLFRAME_H_
#define _PIANOROLLFRAME_H_

class CPianoRollFrame : public CChildFrame {
	DECLARE_DYNCREATE (CPianoRollFrame)

	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
protected:
	long m_lToolBar1Height;             // c[o[1̍[pixel]
	long m_lKeyHeight;                  // L[r[(yC)̍[pixel]
	long m_lScaleHeight;                // 㕔ڐr[̍[pixel]
	long m_lVelHeight;                  // xVeBr[(yC)̍[pixel]
	long m_lScaleWidth;                 // ڐr[̕[pixel]
	long m_lTimeWidth;                  // ԃr[(yC)̕[pixel]
	long m_lHScrollBarHeight;           // XN[o[̍[pixel]
	long m_lVScrollBarWidth;            // XN[o[̕[pixel]
	long m_lTrackListWidth;             // gbNXg(EyC)̕[pixel]
	long m_lKeyZoom;                    // L[g{[{]
	long m_lTimeZoom;                   // ^Cg{[{]
	long m_lVelZoom;                    // xVeBY[{[{]
	long m_lKeyScrollPos;               // L[XN[ʒu[pixel]
	long m_lVelScrollPos;               // xVeBXN[ʒu[pixel]
	long m_lTimeScrollPos;              // ԕXN[ʒu[pixel]
public:
	CFont m_theFont;                    // sAm[EBhEŎgtHg
public:
	CSekaijuToolBar m_wndToolBar1;      // c[o[1
	CColorfulComboBox m_wndTrackCombo;  // gbNR{{bNX
	CComboBox m_wndChannelCombo;        // `lR{{bNX
	CComboBox m_wndSnapCombo;           // XibvR{{bNX
	CComboBox m_wndVelocityCombo;       // xVeBR{{bNX
	CComboBox m_wndDurationCombo;       // R{{bNX
	CComboBox m_wndGraphKindCombo;      // Ot̎ރR{{bNX
	CComboBox m_wndGraphSnapCombo;      // OtXibvR{{bNX
	CView* m_pDummyView;                // _~[r[(Visible=FALSE)ւ̃|C^
	CView* m_pPrintView;                // pr[(Visible=FALSE)ւ̃|C^
	CView* m_pScaleView;                // ڐr[ւ̃|C^
	CView* m_pTimeScaleView;            // Ԗڐr[ւ̃|C^
	CView* m_pKeyScaleView;             // Kڐr[ւ̃|C^
	CView* m_pKeyTimeView;              // K-ԃr[ւ̃|C^
	CView* m_pVelScaleView;             // xVeBڐr[ւ̃|C^
	CView* m_pVelTimeView;              // xVeB-ԃr[ւ̃|C^
	CCheckListBox* m_pTrackListBox;     // gbNXg{bNXւ̃|C^
	CCheckListBox* m_pGraphKindListBox; // Ot̎ރXg{bNX
	CScrollBar m_wndTimeScroll;         // ԕXN[o[
	CScrollBar m_wndKeyScroll;          // KXN[o[
	CScrollBar m_wndVelScroll;          // xVeBXN[o[
	CScrollBar m_wndSizeScroll;         // TCYύXXN[o[
	CBitmapButton m_wndTimeZoomUp;      // ԕg{^
	CBitmapButton m_wndTimeZoomDown;    // ԕk{^
	CBitmapButton m_wndVelZoomUp;       // xVeBg{^
	CBitmapButton m_wndVelZoomDown;     // xVeBk{^
	CBitmapButton m_wndKeyZoomUp;       // L[g{^
	CBitmapButton m_wndKeyZoomDown;     // L[k{^
protected:
	CPoint m_ptMouseDown;               // }EXꂽƂ̍W(Xvb^[𓮂̂Ɏg)
	CPoint m_ptMouseMoveOld;            // }EXꂽƂ̑O̍W(Xvb^[𓮂̂Ɏg)
	BOOL m_bSplitterMovingH;            // ݐXvb^[𓮂ĂƂ납H
	BOOL m_bSplitterMovingV;            // ݐXvb^[𓮂ĂƂ납H
public:
	BOOL m_bAutoPageUpdate;             // IɃy[WXV邩H
	long m_lCurTool;                    // ݂̑IĂc[(0=`,1=,2=S,3=I,4=)
protected:
	BOOL m_bOnlyCurTrack;               // ݂̃gbN݂̂\邩H
	BOOL m_bShowAllTrack;               // ׂẴgbN\邩H
	BOOL m_bTrackVisible[MAXMIDITRACKNUM]; // gbN[0`65535]͉H
	BOOL m_bOnlyCurGraph;               // ݂̃Ot݂̂\邩H
	BOOL m_bShowAllGraph;               // ׂẴOt\邩H
	BOOL m_bGraphVisible[256];          // Ot[0`255]͉H

	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CPianoRollFrame ();                 // RXgN^
	virtual ~CPianoRollFrame();         // fXgN^

	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
public:
	virtual CSekaijuDoc* GetDocument ();
	virtual long GetTimeZoom ();
	virtual long GetKeyZoom ();
	virtual long GetVelZoom ();
	virtual long XtoTime (long x);
	virtual long TimetoX (long lTime);
	virtual long YtoKey (long y);
	virtual long KeytoY (long lKey);
	virtual long YtoPitchBend (long y);
	virtual long YtoVel (long y);
	virtual long YtoTempoBPM (long y);
	virtual long VeltoY (long lVel);
	virtual long PitchBendtoY (long lPitchBend);
	virtual long TempoBPMtoY (long lTempo);
	virtual long GetTimeScrollPos ();
	virtual long GetKeyScrollPos ();
	virtual long GetVelScrollPos ();
	virtual long SetTimeScrollPos (long lTimeScrollPos);
	virtual long SetKeyScrollPos (long lKeyScrollPos);
	virtual long SetVelScrollPos (long lVelScrollPos);
	virtual long GetVisibleLeftTime ();
	virtual long GetVisibleRightTime ();
	virtual long GetVisibleTopKey ();
	virtual long GetVisibleBottomKey ();
	virtual long GetVisibleTopVel ();
	virtual long GetVisibleBottomVel ();
	virtual void DrawSplitterCaptor (CDC* pDC, CPoint pt);
	virtual long GetCurTrackIndex ();
	virtual long GetCurChannel ();
	virtual long GetCurSnap ();
	virtual long GetCurVelocity ();
	virtual long GetCurDuration ();
	virtual long GetCurGraphKind ();
	virtual long GetCurGraphSnap ();
	virtual BOOL SetCurTrackIndex (long lCurTrackIndex);
	virtual BOOL SetCurChannel (long lCurChannel);
	virtual BOOL SetCurSnap (long lCurSnap);
	virtual BOOL SetCurVelocity (long lCurVelocity);
	virtual BOOL SetCurDuration (long lCurDuration);
	virtual BOOL SetCurGraphKind (long lCurGraphKind);
	virtual BOOL SetCurGraphSnap (long lCurGraphKind);
	virtual BOOL IsTrackVisible (long lTrackIndex);
	virtual BOOL SetTrackVisible (long lTrackIndex);
	virtual BOOL IsGraphVisible (long lGraphKind);
	virtual BOOL SetGraphVisible (long lGraphKind);
	virtual BOOL UpdateTrackCombo ();
	virtual BOOL UpdateGraphKindCombo ();
	virtual BOOL UpdateTrackList ();
	virtual BOOL UpdateGraphKindList ();
	virtual BOOL UpdateSnapCombo ();
	virtual BOOL UpdateVelocityCombo ();
	virtual BOOL UpdateDurationCombo ();
	virtual BOOL UpdateGraphSnapCombo ();
	virtual void RecalcKeyScrollInfo ();
	virtual void RecalcVelScrollInfo ();
	virtual void RecalcTimeScrollInfo ();


	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
	virtual void OnUpdateFrameTitle (BOOL bAddToTitle);
	virtual void RecalcLayout (BOOL bNotify = TRUE);
	virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy ();
	afx_msg void OnSize (UINT nType, int cx, int cy);
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd (CDC* pDC);
	afx_msg void OnMDIActivate (BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd);
	afx_msg void OnPaint ();
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnTimeZoomDown ();
	afx_msg void OnTimeZoomUp ();
	afx_msg void OnKeyZoomDown ();
	afx_msg void OnKeyZoomUp ();
	afx_msg void OnVelZoomDown ();
	afx_msg void OnVelZoomUp ();
	afx_msg void OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPianoRollPen ();
	afx_msg void OnUpdatePianoRollPenUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollLine ();
	afx_msg void OnUpdatePianoRollLineUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollEraser ();
	afx_msg void OnUpdatePianoRollEraserUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollSelect ();
	afx_msg void OnUpdatePianoRollSelectUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollSpeaker ();
	afx_msg void OnUpdatePianoRollSpeakerUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollOnlyCurTrack ();
	afx_msg void OnUpdatePianoRollOnlyCurTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollShowAllTrack ();
	afx_msg void OnUpdatePianoRollShowAllTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollOnlyCurGraph ();
	afx_msg void OnUpdatePianoRollOnlyCurGraphUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollShowAllGraph ();
	afx_msg void OnUpdatePianoRollShowAllGraphUI (CCmdUI* pCmdUI);
	afx_msg void OnPianoRollAutoPageUpdate ();
	afx_msg void OnUpdatePianoRollAutoPageUpdateUI (CCmdUI* pCmdUI);

	afx_msg void OnTrackComboSelEndOK ();	
	afx_msg void OnTrackListChkChange ();
	afx_msg void OnTrackListSelChange ();
	afx_msg void OnGraphKindComboSelEndOK ();	
	afx_msg void OnGraphKindListChkChange ();
	afx_msg void OnGraphKindListSelChange ();

	afx_msg void OnPopupEventProperty ();
	afx_msg void OnUpdatePopupEventPropertyUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupTrackVisibleOn ();
	afx_msg void OnUpdatePopupTrackVisibleOnUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupTrackVisibleOff ();
	afx_msg void OnUpdatePopupTrackVisibleOffUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupTrackVisibleAll ();
	afx_msg void OnUpdatePopupTrackVisibleAllUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupGraphKindVisibleOn ();
	afx_msg void OnUpdatePopupGraphKindVisibleOnUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupGraphKindVisibleOff ();
	afx_msg void OnUpdatePopupGraphKindVisibleOffUI (CCmdUI* pCmdUI);
	afx_msg void OnPopupGraphKindVisibleAll ();
	afx_msg void OnUpdatePopupGraphKindVisibleAllUI (CCmdUI* pCmdUI);

	DECLARE_MESSAGE_MAP()
};


#endif

