//******************************************************************************
// MIDIV[PT[\tgwEx
// EAvP[VNX
// (C)2002-2013 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef _AFXWIN_H_
#define _AFXWIN_H_

#include <afxmt.h>

#define MAXMIDIINDEVICENUM 16           // őMIDI̓foCX
#define MAXMIDIOUTDEVICENUM 16          // őMIDIo̓foCX
#define MAXMIDITRACKNUM 65536           // őMIDIgbN(1MIDIf[^ɕt)
#define MAXMIDIINSTRUMENTNUM 256        // őMIDICXgDg(*.ins)

#define WM_COMMANDWAKEUP (WM_USER + 0)
#define WM_COMMANDREADSHM (WM_USER + 1)
#define WM_COMMANDFILEOPEN (WM_USER + 2)
#define SHMSIZE 1024

// ėp}N(ŏAőAݍ)
#ifndef MIN
#define MIN(A,B) ((A)>(B)?(B):(A))      // AB̏قԂ
#endif
#ifndef MAX
#define MAX(A,B) ((A)>(B)?(A):(B))      // AB̑傫قԂ
#endif
#ifndef CLIP
#define CLIP(A,B,C) ((A)>(B)?(A):((B)>(C)?(C):(B))) //BAC̊ԂŊۂ߂lԂ
#endif

// TSIZEOF}N //20120211ǉ
#ifndef TSIZEOF
#define TSIZEOF(STR) (sizeof(STR)/sizeof(TCHAR))
#endif
#ifndef TCSLEN
#ifdef UNICODE
#define TCSLEN(STRING) wcslen(STRING)
#else
#define TCSLEN(STRING) strlen(STRING)
#endif
#endif
#ifndef TCSNCPY
#ifdef UNICODE
#define TCSNCPY(STRING1,STRING2,N) wcsncpy(STRING1,STRING2,N)
#else
#define TCSNCPY(STRING1,STRING2,N) strncpy(STRING1,STRING2,N)
#endif
#endif

// SendDiffrentStatus̃tOp
#define SDS_NOTEOFF 0x0001              // m[gIt̏ԂŐVԂɕ
#define SDS_NOTEON 0x0002               // m[gȈԂŐVԂɕ
#define SDS_NOTE (SDS_NOTEOFF | SDS_NOTEON) // m[g̏ԂŐVԂɕ
#define SDS_KEYAFTER 0x0004             // L[At^[^b`̒lŐVԂɕ
#define SDS_CONTROLCHANGE 0x0008        // Rg[`FW̒lŐVԂɕ
#define SDS_PROGRAMCHANGE 0x0010        // vO`FW̒lŐVԂɕ
#define SDS_CHANNELAFTER 0x0020         // `lAt^[^b`̒lŐVԂɕ
#define SDS_PITCHBEND 0x0040            // sb`xh̒lŐVԂɕ
#define SDS_RPN 0x0100                  // RPN̒lŐVԂɕ
#define SDS_NRPN 0x0200                 // NRPN̒lŐVԂɕ
#define SDS_MASTERVOLUME 0x0400         // }X^[{[̒lŐVԂɕ
#define SDS_ALL 0xFFFF                  // ׂĂ̒lŐVԂɕ

#include "resource.h"                   // C V{

// EBhE̔zu
typedef struct {
	int m_bIconic;                      // ACRĂ邩H
	int m_bZoomed;                      // ő剻Ă邩H
	int m_nX;                           // CEBhEXW[pixel]
	int m_nY;                           // CEBhEYW[pixel]
	int m_nWidth;                       // CEBhE̕[pixel]
	int m_nHeight;                      // CEBhE̍[pixel]
} WindowPlacement;

// gbN̕ύX_CAO
typedef struct {
	int m_nAmount;                      // gbNԍ͕ύX
	int m_nUnit;                        // P(0=Ύw,1=Εω)
	int m_nFitChannel;                  // eCxg̃`lo̓gbÑ`lɍ킹B
} EditTrackDlgStatus;

// ^C̕ύX(TPQNx[Xp)_CAO
typedef struct {
	int m_nAmount;                      // ^C̕ύX
	int m_nUnit;                        // P(0=,1=,2=eBbN,3=p[Zg)
} EditTimeDlgStatus;

// ^C̕ύX(SMPTEx[Xp)_CAO
typedef struct {
	int m_nAmount;                      // ^C̕ύX
	int m_nUnit;                        // P(0=Tut[,1=t[,2=p[Zg)
} EditTimeSmpDlgStatus;

// `l̕ύX_CAȌ
typedef struct {
	int m_nAmount;                      // gbNԍ͕ύX
	int m_nUnit;                        // P(0=Ύw,1=Εω)
} EditChannelStatus;

// L[̕ύX_CAȌ
typedef struct {
	int m_nAmount;                      // ̕ύX
	int m_nUnit;                        // P(0=, 1=IN^[u)
	int m_nTargetNote;                  // m[gIEm[gItΏۂƂ(0/1)
	int m_nTargetKeyAfter;              // L[At^[^b`ΏۂƂ(0/1)
} EditKeyDlgStatus;

// xVeB̕ύX_CAȌ
typedef struct {
	int m_nAmount;                      // xVeB̕ύX
	int m_nUnit;                        // P(0=,1=p[Zg)
	int m_nTargetNoteOn;                // m[gIΏۂɂ(0/1)
	int m_nTargetNoteOff;               // m[gItΏۂɂ(0/1)
} EditVelocityDlgStatus;

// ̕ύX_CAȌ
typedef struct {
	int m_nAmount;                      // ̕ύX
	int m_nUnit;                        // P(0=eBbN, 1=p[Zg)
} EditDurationDlgStatus;

// l̕ύX_CAȌ
typedef struct {
	int m_nAmount;                      // l̕ύX
	int m_nUnit;                        // P(0=,1=p[Zg)
	int m_nTargetKeyAfter;              // L[At^[^b`ΏۂƂ(0/1)
	int m_nTargetControlChange;         // Rg[`FWΏۂƂ(0/1)
	int m_nTargetChannelAfter;          // `lAt^[^b`ΏۂƂ(0/1)
	int m_nTargetPitchBend;             // sb`xhΏۂƂ(0/1)
} EditValueDlgStatus;

// ̍וƃg_CAȌ
typedef struct {
	int m_nDurationIndex;               // ו1̉CfbNX(0=4`)
	int m_nEnableTrill;                 // gLɂ邩H
	int m_nKeyShift;                    // g̃L[Vtg
} EditBreakupAndTrillDlgStatus;

// NH^CY_CAȌ
typedef struct {
	int m_nSnapTimeIndex;               // Xibv^CCfbNX(0=4`)
	int m_nStrength;                    // x[%]
	int m_nTargetNoteOn;                // ^[Qbgm[gI
	int m_nTargetNoteOff;               // ^[Qbgm[gIt
} EditQuantizeDlgStatus;


// r[goƃe|}_CAȌ
typedef struct {
	int m_nBeatTrackIndex;              // r[gLqꂽgbNԍ(0`65535)
	int m_nBeatIntervalIndex;           // r[gԊu(1`)[tick]
	int m_nInsertTempo;                 // e|}邩H
} EditBeatScanDlgStatus;

// Xg[N_CAȌ
typedef struct {
	int m_nDeltaTime;                   // f^^C(1`)[tick]
	int m_nMode;                        // [h(0=Up,1=Down,2=Up-Down,3=DwonUp)
} EditStrokeDlgStatus;

// ߂̑}_CAȌ
typedef struct {
	int m_nPosition;                    // ʒu
	int m_nNumMeasure;                  // ߐ
} EditInsertMeasureDlgStatus;

// ߂̏_CAȌ
typedef struct {
	int m_nPosition;                    // ʒu
	int m_nNumMeasure;                  // ߐ
} EditRemoveMeasureDlgStatus;

// gm[_CAȌ
typedef struct {
	int m_nOn;                          // gm[I
	int m_nOutputPort;                  // o̓|[g(0`15)
	int m_nOutputChannel;               // o̓`l(0`15)
	int m_nNoteKey1;                    // Ńm[gL[(0`127)
	int m_nNoteVel1;                    // ŃxVeB(1`127)
	int m_nNoteKey2;                    // Ńm[gL[(0`127)
	int m_nNoteVel2;                    // ŃxVeB(1`127)
} MetronomeDlgStatus;

// ۑ_CAȌ
typedef struct {
	int m_nOn;                          // ۑI
	long m_lInterval;                   // ۑԊu(1`7200)[b]
	int m_nDisableWhilePlaying;         // t͎ۑȂ
	int m_nDisableWhileRecording;       // A^C͎͒ۑȂ
} AutoSaveDlgStatus;

// IvV()y[W̏
typedef struct {
	BOOL m_bEnableMultiExec;            // ̐EN邱Ƃ
	BOOL m_bEnableMultiOpen;            // MIDIf[^JƂ
	BOOL m_bRestoreWindowPlacement;     // NɑÕEBhEʒu𕜌
	BOOL m_bExecOpen;                   // NɍŌɊJMIDIf[^IɊJ
	BOOL m_bOpenPlay;                   // MIDIf[^JƎIɉtJn
	BOOL m_bPlayUpdate;                 // tʒuړɃpb`Rg[sb`xhRPNNRPNŐVlɍXV
	BOOL m_bSearchUpdate;               // tJnɃpb`Rg[sb`xhRPNNRPNŐVlɍXV 
	BOOL m_bSearchSysx;                 // tJnɃVXeGNXN[V(}X^[H[Ȃ)ŐVlɍXV
	BOOL m_bEnableCC111Loop;            // I[gs[gCC#111̈ʒu烋[vJn
	BOOL m_bInvertCtrlMouseWheel;       // Ctrl+}EXzC[]̉tʒuړ𔽓]ɂ
	BOOL m_bTrackZeroOrigin;            // gbNԍ0琔
	BOOL m_bEventZeroOrigin;            // Cxgԍ0琔
	BOOL m_bPatchSearch;                // CC#0CC#32vO`FW쎞ɗLȉF
	BOOL m_bEnableAutoPageUpdate;       // tJnEʒuړɎIy[WXVIɂ
	BOOL m_bSendNoteOffHoldOffAtEnd;    // Ȃ̏I[ɒBƂm[gItz[hIt𑗐M
	long m_lUpDownDelta1;               // ̍NbN[+][-]L[ő(1`127)
	long m_lUpDownDelta2;               // ̉ENbN[Shift]+[+][-]L[ő(1`127)
	long m_lKeyVelocity1;               // Ղ̍NbN[Z]-[\]L[ŔxVeB(1`127)
	long m_lKeyVelocity2;               // Ղ̉ENbN[Shift]+[Z]-[\]L[ŔxVeB(1`127)
	long m_lSpeedSlow;                  // Xs[h=ᑬŉt̃e|{(1`<5000>`100000)[*1/100%]
	long m_lSpeedNormal;                // Xs[h=Wŉt̃e|{(1`<10000>`100000)[*1/100%]
	long m_lSpeedFast;                  // Xs[h=ŉt̃e|{(1`<20000>`100000)[*1/100%]
	long m_lPlayRecordInterval;         // MIDIf[^^twhile[vĂяoԊu(1`1000)[~b]
	long m_lOctaveSignature;            // ̃h(60)̵ޔԍ\L(3`5)
} GeneralOption;

// IvV(F)y[W̏
typedef struct {
	long m_lForeColor[8];               // OiF[8](ftHggbNF)
	long m_lBackColor[2];               // wiF[2]
	long m_lHorzColor[2];               // ̐F[2]       
	long m_lVertColor[2];               // ̐F[2]
} ColorOption;

// gbNXgIvVy[W1̐ݒ
typedef struct TTrackListOption1 {
	long m_lDefRowZoom;                 // ftHg̍sg{[{]
	long m_lDefColumnZoom;              // ftHg̗g{[{]
	long m_lDefTimeZoom;                // ftHg̎ԕg{[{]
	long m_lDefNameWidth;               // ftHg̖O̕[pixel]
	long m_lDefColorWidth;              // ftHg̐F̕[pixel]
	long m_lDefInputOnWidth;            // ftHg̓ON̕[pixel]
	long m_lDefInputPortWidth;          // ftHg̓̓|[g̕[pixel]
	long m_lDefInputChWidth;            // ftHg̓CH̕[pixel]
	long m_lDefOutputOnWidth;           // ftHg̏oON̕[pixel]
	long m_lDefOutputPortWidth;         // ftHg̏o̓|[g̕[pixel]
	long m_lDefOutputChWidth;           // ftHg̏oCH̕[pixel]
	long m_lDefViewModeWidth;           // ftHg̕\[h̕[pixel]
} TrackListOption1;

// gbNXgIvVy[W2̐ݒ
typedef struct TTrackListOption2 {
	long m_lDefCC000Width;              // ftHgCC#0̕[pixel]
	long m_lDefCC032Width;              // ftHgCC#32̕[pixel]
	long m_lDefPCWidth;                 // ftHg̃vOio[̕[pixel]
	long m_lDefCC007Width;              // ftHg̃{[̕[pixel]
	long m_lDefCC010Width;              // ftHg̃p̕[pixel]
	long m_lDefCC091Width;              // ftHg̃o[u̕[pixel]
	long m_lDefCC093Width;              // ftHg̃R[X̕[pixel]
	long m_lDefCC094Width;              // ftHg̃fBC̕[pixel]
	long m_lDefKeyShiftWidth;           // ftHg̃L[Vtg̕[pixel]
	long m_lDefVelShiftWidth;           // ftHg̃xVeBVtg̕[pixel]
	long m_lDefTimeShiftWidth;          // ftHg̃^CVtg̕[pixel]
	long m_lDefNumEventWidth;           // ftHg̃Cxg̕[pixel]
	BOOL m_bEnableRowZoomKey;           // Ctrl+'+''-'L[ōsY[邩ǂ
	BOOL m_bEnableColumnZoomKey;        // Ctrl+'+''-'L[ŗY[邩ǂ
	BOOL m_bEnableTimeZoomKey;          // Ctrl+'+''-'L[ŎԕY[邩ǂ
} TrackListOption2;

// sAm[IvVy[W̐ݒ
typedef struct {
	long m_lDefKeyZoom;                 // ftHg̃L[g{[{]
	long m_lDefVelZoom;                 // ftHg̃xVeBg{[{]
	long m_lDefTimeZoom;                // ftHg̎ԕg{[{]
	BOOL m_bEnableKeyZoomKey;           // Ctrl+'+''-'L[ŃL[Y[邩ǂ
	BOOL m_bEnableVelZoomKey;           // Ctrl+'+''-'L[ŃxVeBY[邩ǂ
	BOOL m_bEnableTimeZoomKey;          // Ctrl+'+''-'L[ŎԕgbNY[邩ǂ
	BOOL m_bSpeakerModeVisibleTrack;    // Ԃ̃gbN
	long m_lGraphLineWidth;             // Ot̐[pixel]
} PianoRollOption;

// CxgXgIvVy[W̐ݒ
typedef struct {
	long m_lDefRowZoom;                 // ftHg̍sg{[{]
	long m_lDefColumnZoom;              // ftHg̗g{[{]
	long m_lDefTrackWidth;              // ftHg̃gbN̕[pixel]
	long m_lDefMillisecWidth;           // ftHg̃~b̕[pixel]
	long m_lDefTimeWidth;               // ftHg̃^C̕[pixel]
	long m_lDefKindWidth;               // ftHg̃Cxg̎ނ̕[pixel]
	long m_lDefChWidth;                 // ftHg̃`l̕[pixel]
	long m_lDefVal1Width;               // ftHg̒l1̕[pixel]
	long m_lDefVal2Width;               // ftHg̒l2̕[pixel]
	long m_lDefVal3Width;               // ftHg̒l3̕[pixel]
	BOOL m_bInsertEventAfter;           // ̃Cxg̒ɑ}
	BOOL m_bDuplicateEventAfter;        // ݂̃Cxg̒ɑ}
	BOOL m_bDeleteEventAfter;           // 폜Cxg̎̃CxgɃtH[JX킹
	BOOL m_bEnableRowZoomKey;           // Ctrl+'+''-'L[ōsY[邩ǂ
	BOOL m_bEnableColumnZoomKey;        // Ctrl+'+''-'L[ŗY[邩ǂ
} EventListOption;

// ʃIvVy[W̐ݒ
typedef struct {
	long m_lDefTrackZoom;               // ftHg̃gbNg{[{]
	long m_lDefTimeZoom;                // ftHg̎ԕg{[{]
	BOOL m_bEnableTrackZoomKey;         // Ctrl+'+''-'L[ŃgbNY[邩ǂ
	BOOL m_bEnableTimeZoomKey;          // Ctrl+'+''-'L[ŎԕY[邩ǂ
	BOOL m_bSpeakerModeVisibleTrack;    // Ԃ̃gbN
} MusicalScoreOption;

// vpeBV[ǧ݂̃y[W
typedef struct {
	long m_lMIDIDevice;                 // MIDIfoCX
	long m_lOption;                     // IvV
} CurrentPage;


class CSekaijuApp : public CWinApp {

	
	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CSekaijuApp();                      // RXgN^


	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
public:
	HINSTANCE m_hResourceDLL;
public:
	// hLgev[gւ̃|C^ێ
	CDocTemplate* m_pSekaijuDocTemplate;
public:
	// MIDIfoCXIuWFNgMIDIXe[^XIuWFNg
	MIDIIn*     m_pMIDIIn[MAXMIDIINDEVICENUM];
	MIDIOut*    m_pMIDIOut[MAXMIDIOUTDEVICENUM];
	MIDIStatus* m_pMIDIInStatus[MAXMIDIINDEVICENUM];
	MIDIStatus* m_pMIDIOutStatus[MAXMIDIOUTDEVICENUM];
	MIDIStatus* m_pTempMIDIStatus[MAXMIDIOUTDEVICENUM];
	MIDIInstrument* m_pMIDIInstrument[MAXMIDIINSTRUMENTNUM];
	MIDIInstrumentDefinition* m_pMIDIInstDefNorm[MAXMIDIOUTDEVICENUM];
	MIDIInstrumentDefinition* m_pMIDIInstDefDrum[MAXMIDIOUTDEVICENUM];
public:
	// MIDIo͂Ȃǂɑ΂NeBJZNV
	CCriticalSection m_theCriticalSection;
public:
	// pX
	CString m_strExeFilePath;           // st@ĈpX
	CString m_strInitialPath;           // init@ĈpX
	CString m_strFileOpenPath;          // t@CI[v_CAÕpX
	CString m_strSysxOpenPath;          // SYSXI[v_CAÕpX

	// MIDIo̓foCX̖O
	CString m_strMIDIInName[MAXMIDIINDEVICENUM];
	CString m_strMIDIOutName[MAXMIDIOUTDEVICENUM];

	// MIDICXgDg`̖O
	CString m_strMIDIInstDefNormName[MAXMIDIOUTDEVICENUM];
	CString m_strMIDIInstDefDrumName[MAXMIDIOUTDEVICENUM];

	// MIDIX[̐ݒ
	BOOL m_bMIDIThru[MAXMIDIINDEVICENUM];

	// MIDI[h
	long m_lMIDIInSyncMode[MAXMIDIINDEVICENUM];
	long m_lMIDIOutSyncMode[MAXMIDIOUTDEVICENUM];

	// Rg[
	BOOL m_bPlaying;       // ttO (0=~,1=t)
	BOOL m_bRecording;     // ^tO (0=~,1=^)
	BOOL m_bAutoRepeat;    // I[gs[g(0=OFF,1=ON)
	long m_lCurSpeedIndex; // Xs[h (0=Î~,1=ᑬ,2=W,3=,4=@ɃX[u)
	long m_lOldSpeedIndex; // Xs[h (0=Î~,1=ᑬ,2=W,3=,4=@ɃX[u)

	// SʃIvV
	GeneralOption m_theGeneralOption;
	
	// FIvV
	ColorOption m_theColorOption;

	// gbNXgIvV1
	TrackListOption1 m_theTrackListOption1;

	// gbNXgIvV2
	TrackListOption2 m_theTrackListOption2;

	// sAm[IvV
	PianoRollOption m_thePianoRollOption;

	// CxgXgIvV
	EventListOption m_theEventListOption;

	// ʃIvV
	MusicalScoreOption m_theMusicalScoreOption;

	// vpeBV[ǧ݂̃y[W	
	CurrentPage m_theCurrentPage;

	// EBhEzu
	WindowPlacement m_theWindowPlacement;

	// EditTrack_CAO
	EditTrackDlgStatus m_theEditTrackDlgStatus;
	
	// EditTime_CAO
	EditTimeDlgStatus m_theEditTimeDlgStatus;

	// EditTimeSmp_CAO
	EditTimeSmpDlgStatus m_theEditTimeSmpDlgStatus;

	// EditChannel_CAO
	EditChannelStatus m_theEditChannelDlgStatus;

	// EditKey_CAO
	EditKeyDlgStatus m_theEditKeyDlgStatus;

	// EditVelocity_CAO
	EditVelocityDlgStatus m_theEditVelocityDlgStatus;

	// EditDuration_CAO
	EditDurationDlgStatus m_theEditDurationDlgStatus;

	// EditValue_CAO
	EditValueDlgStatus m_theEditValueDlgStatus;

	// EditBreakupAndTrill_CAO
	EditBreakupAndTrillDlgStatus m_theEditBreakupAndTrillDlgStatus;

	// EditQuantize_CAO
	EditQuantizeDlgStatus m_theEditQuantizeDlgStatus;

	// EditBeatScan_CAO
	EditBeatScanDlgStatus m_theEditBeatScanDlgStatus;

	// EditStroke_CAO
	EditStrokeDlgStatus m_theEditStrokeDlgStatus;

	// EditInsertMeasure_CAO
	EditInsertMeasureDlgStatus m_theEditInsertMeasureDlgStatus;

	// EditRemoveMeasure_CAO
	EditRemoveMeasureDlgStatus m_theEditRemoveMeasureDlgStatus;

	// Metronome_CAO
	MetronomeDlgStatus m_theMetronomeDlgStatus;

	// ۑ_CAO
	AutoSaveDlgStatus m_theAutoSaveDlgStatus;

	// ŌɊJt@C
	CString m_strLastOpenFileName[16];

	// 
	CString m_strLanguage;

	// ftHgtHg
	CFont m_theDefaultFont;

	// J[\
	HCURSOR m_hCursorArrow;
	HCURSOR m_hCursorCross;
	HCURSOR m_hCursorSizeWE;
	HCURSOR m_hCursorSizeNS;
	HCURSOR m_hCursorSizeAll;
	HCURSOR m_hCursorSizeAllCopy;
	HCURSOR m_hCursorNo;
	HCURSOR m_hCursorResizeWE;
	HCURSOR m_hCursorResizeNS;
	HCURSOR m_hCursorResizeAll;
	HCURSOR m_hCursorDraw;
	HCURSOR m_hCursorLine;
	HCURSOR m_hCursorEraser;
	HCURSOR m_hCursorSelect;
	HCURSOR m_hCursorSelectAdd;
	HCURSOR m_hCursorSelect2;
	HCURSOR m_hCursorSelectAdd2;
	HCURSOR m_hCursorSpeaker;

	// Cxg̎ޖ
	CString m_strEventKindName[256];

	// m[gL[
	CString m_strNoteKeyName[256];

	// ꎞIȕϐ
	BOOL m_bIgnoreNoteEvent;
	BOOL m_bFirstMetronome;
	CPtrArray m_theTempRecordedEventArray;
	BOOL m_bInplaceEditing;
	BOOL m_bInplaceListing;
	BOOL m_bValueUpDowning;

	// ݂̎qEBhEƌ݂̃hLg
	CMDIChildWnd* m_pCurChildWnd;
	CDocument* m_pCurDocument;
	CMDIChildWnd* m_pOldChildWnd;
	CDocument* m_pOldDocument;

	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual BOOL InitInstance ();
	virtual int  ExitInstance ();
	virtual void AddDocTemplate (CDocTemplate* pTemplate);
	virtual BOOL PreTranslateMessage (MSG* pMsg);
  	virtual BOOL OnIdle (LONG lCount);

	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
public:
	virtual BOOL LoadResourceDLL ();
	virtual BOOL FreeResourceDLL ();
	virtual BOOL CheckMultiExec (CCommandLineInfo* pCmdInfo);
	virtual DWORD CSekaijuApp::GetPrivateProfileStringEx 
		(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPCTSTR lpDefault, 
		LPTSTR lpReturnedString, DWORD nSize, LPCTSTR lpFileName);
	virtual CString CSekaijuApp::GetProfileStringEx 
		(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault);
	virtual void CleanIniFile ();
	virtual BOOL LoadIniFile ();
	virtual BOOL SaveIniFile ();
	virtual void UpdateMenu ();
	virtual void UpdateCurWndAndDocPtr ();
	virtual void ResetMIDIStatusArray ();
	virtual void ResetTempMIDIStatusArray ();
	virtual void SendAllHold1Off ();
	virtual void SendAllSostenutoOff ();
	virtual void SendAllHold2Off ();
	virtual void SendAllSoundOff ();
	virtual void SendResetAllController ();
	virtual void SendAllNoteOff ();
	virtual void SendDifferentStatus (long lFlags);
	virtual void OpenAllMIDIInDevice ();
	virtual void OpenAllMIDIOutDevice ();
	virtual long LoadAllMIDIInstrument ();
	virtual long SelectAllMIDIInstDefNorm ();
	virtual long SelectAllMIDIInstDefDrum ();
	virtual long SetPlayPosition (CDocument* pDocument, long lTargetTime);
	virtual long StartPlaying (CDocument* pDocument);
	virtual long StopPlaying (CDocument* pDocument);
	virtual long StartRecording (CDocument* pDocument);
	virtual long StopRecording (CDocument* pDocument);
	virtual void ApplyMIDIDeviceSheet (CPropertySheet* pSheet);
	virtual void ApplyMIDISyncModeSheet (CPropertySheet* pSheet);
	virtual void ApplyOptionSheet (CPropertySheet* pSheet);
	virtual BOOL GetCurSyncInputPortAndMode (long* pPort, long* pMode);

public:
	// tE^pXbh֘A
	static UINT PlayRecordThread (LPVOID pInfo);
	virtual BOOL PlayRecordProc (LPVOID pInfo);
	CWinThread* m_pPlayRecordThread;
	BOOL m_bPlayRecordThreadRunning;

	//--------------------------------------------------------------------------
	// Cve[V
	//--------------------------------------------------------------------------
protected:
	afx_msg void OnUpdateFileNewUI (CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpenUI (CCmdUI* pCmdUI);
	afx_msg void OnControlToBegin ();
	afx_msg void OnUpdateControlToBeginUI (CCmdUI* pCmdUI);
	afx_msg void OnControlToEnd ();
	afx_msg void OnUpdateControlToEndUI (CCmdUI* pCmdUI);
	afx_msg void OnControlPlay ();
	afx_msg void OnUpdateControlPlayUI (CCmdUI* pCmdUI);
	afx_msg void OnControlRecord ();
	afx_msg void OnUpdateControlRecordUI (CCmdUI* pCmdUI);
	afx_msg void OnControlPrevMeasure ();
	afx_msg void OnUpdateControlPrevMeasureUI (CCmdUI* pCmdUI);
	afx_msg void OnControlNextMeasure ();
	afx_msg void OnUpdateControlNextMeasureUI (CCmdUI* pCmdUI);
	afx_msg void OnControlPrevBeat ();
	afx_msg void OnUpdateControlPrevBeatUI (CCmdUI* pCmdUI);
	afx_msg void OnControlNextBeat ();
	afx_msg void OnUpdateControlNextBeatUI (CCmdUI* pCmdUI);
	afx_msg void OnControlSpeedNone ();
	afx_msg void OnUpdateControlSpeedNoneUI (CCmdUI* pCmdUI);
	afx_msg void OnControlSpeedSlow ();
	afx_msg void OnUpdateControlSpeedSlowUI (CCmdUI* pCmdUI);
	afx_msg void OnControlSpeedNormal ();
	afx_msg void OnUpdateControlSpeedNormalUI (CCmdUI* pCmdUI);
	afx_msg void OnControlSpeedFast ();
	afx_msg void OnUpdateControlSpeedFastUI (CCmdUI* pCmdUI);
	afx_msg void OnControlSpeedSlave ();
	afx_msg void OnUpdateControlSpeedSlaveUI (CCmdUI* pCmdUI);
	afx_msg void OnControlAutoRepeat ();
	afx_msg void OnUpdateControlAutoRepeatUI (CCmdUI* pCmdUI);
	afx_msg void OnSetupMIDIDevice ();
	afx_msg void OnSetupMIDISyncMode ();
	afx_msg void OnSetupInstrument ();
	afx_msg void OnSetupMetronome ();
	afx_msg void OnSetupAutoSave ();
	afx_msg void OnSetupLanguage ();
	afx_msg void OnSetupOptions ();
	afx_msg void OnHelpReadMe ();
	afx_msg void OnHelpLicense ();
	afx_msg void OnHelpManual ();
	afx_msg void OnHelpProjectHomePage ();
	afx_msg void OnHelpAbout ();
	DECLARE_MESSAGE_MAP()
};

#endif
