//******************************************************************************
// MIDIV[PT[\tgwEx
// gbNXgt[EBhENX
// (C)2002-2012 [ՂMIDIՂ낶Ɓ^
//******************************************************************************

/* This library is free software; you can redistribute it and/or */
/* modify it under the terms of the GNU Lesser General Public */
/* License as published by the Free Software Foundation; either */
/* version 2.1 of the License, or (at your option) any later version. */

/* This library is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/* Lesser General Public License for more details. */

/* You should have received a copy of the GNU Lesser General Public */
/* License along with this library; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#define TRACKLISTFRAME_NUMCOLUMN 21

#define TRACKLISTFRAME_TRACKNAME     0x01
#define TRACKLISTFRAME_VISIBLE       0x30
#define TRACKLISTFRAME_ENABLE        0x31
#define TRACKLISTFRAME_VIEWMODE      0x33
#define TRACKLISTFRAME_FORECOLOR     0x34
#define TRACKLISTFRAME_BACKCOLOR     0x35
#define TRACKLISTFRAME_INPUTON       0x36
#define TRACKLISTFRAME_INPUTPORT     0x37
#define TRACKLISTFRAME_INPUTCHANNEL  0x38
#define TRACKLISTFRAME_OUTPUTON      0x39
#define TRACKLISTFRAME_OUTPUTPORT    0x3A
#define TRACKLISTFRAME_OUTPUTCHANNEL 0x3B
#define TRACKLISTFRAME_TIMEPLUS      0x3C
#define TRACKLISTFRAME_KEYPLUS       0x3D
#define TRACKLISTFRAME_VELOCITYPLUS  0x3E
#define TRACKLISTFRAME_NUMEVENT      0xFF
#define TRACKLISTFRAME_CONTROLCHANGE 0xB0
#define TRACKLISTFRAME_PROGRAMCHANGE 0xC0

#ifndef _TRACKLISTFRAME_H_
#define _TRACKLISTFRAME_H_

class CTrackListFrame : public CChildFrame {
	DECLARE_DYNCREATE (CTrackListFrame)

	//--------------------------------------------------------------------------
	// Agr[g
	//--------------------------------------------------------------------------
protected:
	long m_lToolBar1Height;             // c[o[̍[pixel]
	long m_lScaleHeight;                // 㕔ڐr[̍[pixel]
	long m_lScaleWidth;                 // ڐr[̕[pixel]
	long m_lTrackHeight;                // gbNr[̍[pixel]
	long m_lModeWidth;                  // [hr[(yC)̕[pixel]
	long m_lTimeWidth;                  // ^Cr[(EyC)̕[pixel]
	long m_lHScrollBarHeight;           // XN[o[̍[pixel]
	long m_lVScrollBarWidth;            // XN[o[̕[pixel]
	long m_lColumnZoom;                 // g{[{]
	long m_lTimeZoom;                   // ԕg{[{]
	long m_lRowZoom;                    // sg{[{]
	long m_lColumnScrollPos;            // XN[ʒu[pixel]
	long m_lTimeScrollPos;              // ԕXN[ʒu[pixel]
	long m_lRowScrollPos;               // sXN[ʒu[pixel]
	long m_lColumnBaseWidth[TRACKLISTFRAME_NUMCOLUMN];  // e̕(g{ĂȂ)[pixel]
	CString m_strColumnTitle[TRACKLISTFRAME_NUMCOLUMN]; // ẽ^Cg
	long m_lColumnContent[TRACKLISTFRAME_NUMCOLUMN];    // e̕\eʃR[h
	// e̕\eʃR[h́A
	// TRACKLISTFRAME_TRACKNAME`TRACKLISTFRAME_PROGRAMCHANGE̒IB
	// TRACKLISTFRAME_CONTROLCHANGEł9`16rbgڂCC#ԍw肷B

public:
	CSekaijuToolBar m_wndToolBar1;      // c[o[
	CView* m_pDummyView;                // _~[r[(Visible=FALSE)ւ̃|C^
	CView* m_pPrintView;                // r[(Visible=FALSE)ւ̃|C^
	CView* m_pScaleView;                // ڐr[ւ̃|C^
	CView* m_pModeScaleView;            // ږڐr[ւ̃|C^
	CView* m_pTimeScaleView;            // ^Cڐr[ւ̃|C^
	CView* m_pTrackScaleView;           // gbNԍڐr[ւ̃|C^
	CView* m_pTrackModeView;            // gbNԍ-ڃr[(yC)ւ̃|C^
	CView* m_pTrackTimeView;            // gbNԍ-^Cr[(EyC)ւ̃|C^
	CScrollBar m_wndColumnScroll;       // XN[o[
	CScrollBar m_wndTimeScroll;         // ԕXN[o[
	CScrollBar m_wndRowScroll;          // sXN[o[
	CScrollBar m_wndSizeScroll;         // TCYXN[o[
	CBitmapButton m_wndColumnZoomUp;    // g{^
	CBitmapButton m_wndColumnZoomDown;  // k{^
	CBitmapButton m_wndTimeZoomUp;      // ԕg{^
	CBitmapButton m_wndTimeZoomDown;    // ԕk{^
	CBitmapButton m_wndRowZoomUp;       // sg{^
	CBitmapButton m_wndRowZoomDown;     // sk{^

public:
	CFont m_theFont;                    // gbNr[EBhEŎgtHg
	long m_lCurTool;                    // ݑIĂc[ԍ(0=I,1=)
	BOOL m_bAutoPageUpdate;             // IɃy[WXV邩H

protected:
	CPoint m_ptMouseDown;               // }EXꂽW(Xvb^[𓮂̂Ɏg)
	CPoint m_ptMouseMoveOld;            // }EXꂽO̍W(Xvb^[𓮂̂Ɏg)


	//--------------------------------------------------------------------------
	// \zƔj
	//--------------------------------------------------------------------------
public:
	CTrackListFrame ();                 // RXgN^
	virtual ~CTrackListFrame();         // fXgN^


	//--------------------------------------------------------------------------
	// Iy[V
	//--------------------------------------------------------------------------
public:
	CSekaijuDoc* GetDocument ();
	virtual long GetColumnBaseWidth (long lColumn);
	virtual long SetColumnBaseWidth (long lColumn, long lColumnBaseWidth);
	virtual CString GetColumnTitle (long lColumn);
	virtual long GetColumnContent (long lColumn);
	virtual long GetRowZoom ();
	virtual long GetColumnZoom ();
	virtual long GetTimeZoom ();
	virtual long GetColumnLeft (long lColumn);
	virtual long GetColumnWidth (long lColumn);
	virtual long XtoColumn (long x);
	virtual long ColumntoX (long lMode);
	virtual long XtoTime (long x);
	virtual long TimetoX (long lTime);
	virtual long YtoRow (long y);
	virtual long RowtoY (long lKey);
	virtual long GetVisibleTopRow ();
	virtual long GetVisibleBottomRow ();
	virtual long GetVisibleLeftTime ();
	virtual long GetVisibleRightTime ();
	virtual long GetTimeScrollPos ();
	virtual long GetRowScrollPos ();
	virtual long GetColumnScrollPos ();
	virtual long SetTimeScrollPos (long lTimeScrollPos);
	virtual long SetColumnScrollPos (long lModeScrollPos);
	virtual long SetRowScrollPos (long lTrackScrollPos);
	virtual void DrawSplitterCaptor (CDC* pDC, CPoint pt);
	virtual void RecalcRowScrollInfo ();
	virtual void RecalcColumnScrollInfo ();
	virtual void RecalcTimeScrollInfo ();


	//--------------------------------------------------------------------------
	// I[o[Ch
	//--------------------------------------------------------------------------
protected:
	virtual BOOL PreCreateWindow (CREATESTRUCT& cs);
	virtual void OnUpdateFrameTitle (BOOL bAddToTitle);
	virtual void RecalcLayout (BOOL bNotify = TRUE);
	virtual BOOL OnCreateClient (LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL OnCmdMsg (UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

	//--------------------------------------------------------------------------
	// bZ[W}bv
	//--------------------------------------------------------------------------
protected:
	afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy ();
	afx_msg void OnSize (UINT nType, int cx, int cy);
	afx_msg void OnTimer (UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd (CDC* pDC);
	afx_msg void OnPaint( );
	afx_msg void OnMDIActivate (BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd);
	afx_msg void OnClose ();
	afx_msg void OnKeyDown (UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown (UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp (UINT nFlags, CPoint point);
	afx_msg void OnMouseMove (UINT nFlags, CPoint point);
	afx_msg void OnColumnZoomDown ();
	afx_msg void OnColumnZoomUp ();
	afx_msg void OnTimeZoomDown ();
	afx_msg void OnTimeZoomUp ();
	afx_msg void OnRowZoomDown ();
	afx_msg void OnRowZoomUp ();
	afx_msg void OnVScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll (UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTrackListInsertTrack ();
	afx_msg void OnUpdateTrackListInsertTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListDuplicateTrack ();
	afx_msg void OnUpdateTrackListDuplicateTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListDeleteTrack ();
	afx_msg void OnUpdateTrackListDeleteTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListMoveUpTrack ();
	afx_msg void OnUpdateTrackListMoveUpTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListMoveDownTrack ();
	afx_msg void OnUpdateTrackListMoveDownTrackUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListSelect ();
	afx_msg void OnUpdateTrackListSelectUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListSpeaker ();
	afx_msg void OnUpdateTrackListSpeakerUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListAutoPageUpdate ();
	afx_msg void OnUpdateTrackListAutoPageUpdateUI (CCmdUI* pCmdUI);
	afx_msg void OnTrackListSaveAs ();
	afx_msg void OnUpdateTrackListSaveAsUI (CCmdUI* pCmdUI);


	DECLARE_MESSAGE_MAP()
};


#endif

